package io.xjar.boot;

import io.xjar.XLauncher;
import io.xjar.boot.XBootClassLoader;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.List;
import org.springframework.boot.loader.PropertiesLauncher;

public class XExtLauncher extends PropertiesLauncher {

   private final XLauncher xLauncher;


   public XExtLauncher(String ... args) throws Exception {
      this.xLauncher = new XLauncher(args);
   }

   public static void main(String[] args) throws Exception {
      (new XExtLauncher(args)).launch();
   }

   public void launch() throws Exception {
      this.launch(this.xLauncher.args);
   }

   protected ClassLoader createClassLoader(List archives) throws Exception {
      URLClassLoader classLoader = (URLClassLoader)super.createClassLoader(archives);
      URL[] urls = classLoader.getURLs();
      return new XBootClassLoader(urls, this.getClass().getClassLoader(), this.xLauncher.xDecryptor, this.xLauncher.xEncryptor, this.xLauncher.xKey);
   }
}
